package edu.jhu.cs.oose.group3.intelligentbook.services;

import java.util.List;

import org.hsqldb.lib.Set;

import edu.jhu.cs.oose.group3.intelligentbook.dao.ContactDao;
import edu.jhu.cs.oose.group3.intelligentbook.dao.ContactItemDao;
import edu.jhu.cs.oose.group3.intelligentbook.model.Contact;
import edu.jhu.cs.oose.group3.intelligentbook.model.ContactItem;
import edu.jhu.cs.oose.group3.intelligentbook.model.ContactItemTypes;

/**
 * Provides general services related to Contact.
 */
public class ContactService {
	private ContactDao contactDao;
	private ContactItemDao contactItemDao;
	
	/**
	 * @param contactDao the contactDao to set
	 */
	public void setContactDao(ContactDao contactDao) {
		this.contactDao = contactDao;
	}

	/**
	 * @param contactItemDao the contactItemDao to set
	 */
	public void setContactItemDao(ContactItemDao contactItemDao) {
		this.contactItemDao = contactItemDao;
	}


	
	@SuppressWarnings("unchecked")
	public List getAllContacts() {
		return this.contactDao.getAll();
	}

	public boolean addContact(String firstName, String lastName, String phone) {
		Contact c = new Contact();
		ContactItem ci = new ContactItem();
		ci.setType(ContactItemTypes.FirstName);
		ci.setName("First Name");
		ci.setContents(firstName);
		c.addContactItem(ci.getName(),ci);
		this.contactItemDao.save(ci);
		
		ci = new ContactItem();
		ci.setType(ContactItemTypes.LastName);
		ci.setName("Last Name");
		ci.setContents(lastName);
		c.addContactItem(ci.getName(),ci);
		this.contactItemDao.save(ci);
		
		ci = new ContactItem();
		ci.setName("Phone");
		ci.setType(ContactItemTypes.Phone);
		ci.setContents(phone);
		c.addContactItem(ci.getName(),ci);
		this.contactItemDao.save(ci);
		
		this.contactDao.save(c);
		return true;
		
	}
}
