package edu.jhu.cs.oose.group3.intelligentbook.dao;

import java.util.List;
import java.util.Set;

import org.hibernate.Hibernate;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.springframework.orm.hibernate3.HibernateTemplate;
import org.springframework.transaction.annotation.Transactional;

import edu.jhu.cs.oose.group3.intelligentbook.model.Contact;

/**
 * Deals with the data access object for the contact information.
 *
 */
public class ContactDao {
	private HibernateTemplate hibernateTemplate;
	
	public void save(Contact contact) {
		hibernateTemplate.saveOrUpdate(contact);
	}

	/**
	 * @param hibernateTemplate the hibernateTemplate to set
	 */
	public void setHibernateTemplate(HibernateTemplate hibernateTemplate) {
		this.hibernateTemplate = hibernateTemplate;
	}
	
	@SuppressWarnings("unchecked")
	public List getAll() {
		List allContacts = hibernateTemplate.find("from Contact");
		return allContacts;
	}

}
