package edu.jhu.cs.oose.group3.intelligentbook.model;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import edu.jhu.cs.oose.group3.intelligentbook.util.ContactFinder;
import edu.jhu.cs.oose.group3.intelligentbook.util.Query;

import javax.persistence.Basic;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToOne;
import javax.persistence.MapKey;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;


/** Represents a contact, each of which corresponds to a user */
@Entity
public class Contact {
	
	@Id
	@GeneratedValue
	private long userId;

	//private List<ContactGroup> contactGroups;
	
	@OneToMany(fetch=FetchType.EAGER)
    @MapKey(name="name")
	@JoinTable(
			joinColumns = {@JoinColumn(name="userId")},
			inverseJoinColumns = {@JoinColumn(name="ContactItemId")}
	)
	private Map<String,ContactItem> contactItems = new HashMap<String,ContactItem>();
	
	/** Add a new group to this contact
	 * @param g
	 */
	public void addGroup(ContactGroup g) {
		
	}
	
	/** Remove a group from this contact.
	 * 
	 * Each group member will lose their association with the user unless
	 * they are also a member of a different group
	 * @param g
	 */
	public void removeGroup(ContactGroup g) {
		
	}
	
	/** Get the contact group associated with the given name */
	public ContactGroup getGroup(String name) {
		return null;
	}
	
	/** Get a list of all of this contact's groups */
	public List<ContactGroup> getAllGroups() {
		return null;
	}
	
	/** Associate a new contact item with this contact
	 * @param name
	 * @param item 
	 */
	public void addContactItem(String name, ContactItem item) {
		contactItems.put(name,item);
	}
	/** Remove a contact item from this contact
	 * @param name 
	 */
	public void removeContactItem(String name) {	
	}
	
	/** Get a contact item by name */
	public ContactItem getContactItem(String name) {
		return contactItems.get(name);
	}
	
	/** find a list of contacts using a specific ContactFinder and query
	 * @param finder 
	 * @param q */
	public List<Contact> findContacts(ContactFinder finder, Query q) {
		return null;
	}
	
}
