package edu.jhu.cs.oose.group3.intelligentbook.backingbeans;

import java.util.ArrayList;
import java.util.List;

import edu.jhu.cs.oose.group3.intelligentbook.services.ContactService;
import edu.jhu.cs.oose.group3.intelligentbook.model.Contact;

/**
This package manages and supplies the underlying information for the ViewContact page.
*/
public class ContactListBackingBean {
	private ContactService contactService;

	/**
	 * @return the contactService
	 */
	public ContactService getContactService() {
		return contactService;
	}

	/**
	 * @param contactService the contactService to set
	 */
	public void setContactService(ContactService contactService) {
		this.contactService = contactService;
	}
	
	@SuppressWarnings("unchecked")
	public List<ContactListMember> getContacts() {
		List<ContactListMember> contacts = new ArrayList<ContactListMember>();
		
		List origContacts = contactService.getAllContacts();
		for (Object o: origContacts){
			Contact c = (Contact) o;
			ContactListMember member = new ContactListMember();
			member.setFirstName(c.getContactItem("First Name").getContents());
			member.setLastName(c.getContactItem("Last Name").getContents());
			member.setPhone(c.getContactItem("Phone").getContents());
			contacts.add(member);
		}
		
		return contacts;
	}
	
	public class ContactListMember {
		private String firstName;
		private String lastName;
		private String phone;
		
		/**
		 * @return the firstName
		 */
		public String getFirstName() {
			return firstName;
		}
		/**
		 * @param firstName the firstName to set
		 */
		public void setFirstName(String firstName) {
			this.firstName = firstName;
		}
		/**
		 * @return the lastName
		 */
		public String getLastName() {
			return lastName;
		}
		/**
		 * @param lastName the lastName to set
		 */
		public void setLastName(String lastName) {
			this.lastName = lastName;
		}
		/**
		 * @return the phone
		 */
		public String getPhone() {
			return phone;
		}
		/**
		 * @param phone the phone to set
		 */
		public void setPhone(String phone) {
			this.phone = phone;
		}
		
		public String toString() {
			return firstName + " " + lastName + " " + phone;
		}
	}
	
	
	
	
}
